]> git.ipfire.org Git - ipfire-2.x.git/blame - make.sh
Core Update 164: Ship shadow
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
f06578af 20# Copyright (C) 2007-2021 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
d12e3fcd 27# If you update the version don't forget to update backupiso and add it to core update
255273a3 28VERSION="2.27" # Version number
8c1cc06d 29CORE="164" # Core Level (Filename)
e8ee3199
AF
30SLOGAN="www.ipfire.org" # Software slogan
31CONFIG_ROOT=/var/ipfire # Configuration rootdir
e8ee3199 32MAX_RETRIES=1 # prefetch/check loop
305a7b38 33BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 34KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
36e2e992
MT
35
36# Information from Git
37GIT_BRANCH="$(git rev-parse --abbrev-ref HEAD)" # Git Branch
38GIT_TAG="$(git tag | tail -1)" # Git Tag
39GIT_LASTCOMMIT="$(git rev-parse --verify HEAD)" # Last commit
628e8c3a 40
5e7ba4f4 41TOOLCHAINVER=20210701
03ad5f93 42
178eaf31
AF
43# use multicore and max compression
44ZSTD_OPT="-T0 --ultra -22"
d66e6fa8 45
69a6ec55
MT
46###############################################################################
47#
48# Beautifying variables & presentation & input output interface
49#
50###############################################################################
51
f9783277
MT
52# Remember if the shell is interactive or not
53if [ -t 0 ] && [ -t 1 ]; then
54 INTERACTIVE=true
55else
56 INTERACTIVE=false
57fi
58
401a1edc
MT
59# Sets or adjusts pretty formatting variables
60resize_terminal() {
61 ## Screen Dimentions
62 # Find current screen size
63 COLUMNS=$(tput cols)
64
65 # When using remote connections, such as a serial port, stty size returns 0
66 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
67 COLUMNS=80
68 fi
69a6ec55 69
401a1edc
MT
70 # Measurements for positioning result messages
71 OPTIONS_WIDTH=20
72 TIME_WIDTH=12
73 STATUS_WIDTH=8
74 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
75 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
76
e9a57acd
MT
77 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
78 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 79}
69a6ec55 80
401a1edc
MT
81# Initially setup terminal
82resize_terminal
f9783277 83
401a1edc
MT
84# Call resize_terminal when terminal is being resized
85trap "resize_terminal" WINCH
69a6ec55
MT
86
87# Define color for messages
88BOLD="\\033[1;39m"
89DONE="\\033[1;32m"
90SKIP="\\033[1;34m"
91WARN="\\033[1;35m"
92FAIL="\\033[1;31m"
93NORMAL="\\033[0;39m"
94
bcb9dc13 95# New architecture variables
dc7d6b20 96HOST_ARCH="$(uname -m)"
94571564 97
69a6ec55
MT
98PWD=$(pwd)
99BASENAME=$(basename $0)
100
15679d9f
MT
101# Debian specific settings
102if [ ! -e /etc/debian_version ]; then
df5e82b3 103 FULLPATH=`which $0`
15679d9f 104else
df5e82b3
MT
105 if [ -x /usr/bin/realpath ]; then
106 FULLPATH=`/usr/bin/realpath $0`
107 else
108 echo "ERROR: Need to do apt-get install realpath"
109 exit 1
110 fi
15679d9f 111fi
df5e82b3 112
69a6ec55 113# This is the directory where make.sh is in
aecbe123 114export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 115
ebaecf2c
AF
116LOGFILE=$BASEDIR/log/_build.preparation.log
117export LOGFILE
15679d9f 118DIR_CHK=$BASEDIR/cache/check
ebaecf2c 119mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 120
69a6ec55
MT
121system_processors() {
122 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
123}
124
125system_memory() {
126 local key val unit
127
128 while read -r key val unit; do
129 case "${key}" in
130 MemTotal:*)
131 # Convert to MB
132 echo "$(( ${val} / 1024 ))"
133 break
134 ;;
135 esac
136 done < /proc/meminfo
137}
138
139configure_build() {
140 local build_arch="${1}"
141
142 if [ "${build_arch}" = "default" ]; then
143 build_arch="$(configure_build_guess)"
144 fi
145
146 case "${build_arch}" in
147 x86_64)
148 BUILDTARGET="${build_arch}-unknown-linux-gnu"
149 CROSSTARGET="${build_arch}-cross-linux-gnu"
150 BUILD_PLATFORM="x86"
5eec0f21 151 CFLAGS_ARCH="-m64 -mtune=generic -fstack-clash-protection -fcf-protection"
69a6ec55
MT
152 ;;
153
69a6ec55
MT
154 aarch64)
155 BUILDTARGET="${build_arch}-unknown-linux-gnu"
156 CROSSTARGET="${build_arch}-cross-linux-gnu"
157 BUILD_PLATFORM="arm"
87f3b1e5 158 CFLAGS_ARCH="-fstack-clash-protection"
69a6ec55
MT
159 ;;
160
161 armv7hl)
162 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
163 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
164 BUILD_PLATFORM="arm"
165 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
166 ;;
167
aafdd71b 168 armv6l)
69a6ec55
MT
169 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
170 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
171 BUILD_PLATFORM="arm"
f3fda4d3 172 CFLAGS_ARCH="-march=armv6zk+fp -mfpu=vfp -mfloat-abi=softfp -fomit-frame-pointer"
aafdd71b 173 #RUSTFLAGS="-Ccodegen-units=1"
69a6ec55
MT
174 ;;
175
161eb15d
MT
176 riscv64)
177 BUILDTARGET="${build_arch}-unknown-linux-gnu"
178 CROSSTARGET="${build_arch}-cross-linux-gnu"
179 BUILD_PLATFORM="riscv"
0c304b7b 180 CFLAGS_ARCH="-fstack-clash-protection"
161eb15d
MT
181 ;;
182
69a6ec55
MT
183 *)
184 exiterror "Cannot build for architure ${build_arch}"
185 ;;
186 esac
187
188 # Check if the QEMU helper is available if needed.
189 if qemu_is_required "${build_arch}"; then
190 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
191
192 if [ -n "${qemu_build_helper}" ]; then
193 QEMU_TARGET_HELPER="${qemu_build_helper}"
194 else
195 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
196 fi
197 fi
198
199 BUILD_ARCH="${build_arch}"
200 TOOLS_DIR="/tools_${BUILD_ARCH}"
201
202 # Enables hardening
54114eb0 203 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -Wp,-D_GLIBCXX_ASSERTIONS -fstack-protector-strong"
69a6ec55
MT
204
205 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
206 CXXFLAGS="${CFLAGS}"
207
208 # Determine parallelism
eeee108f 209 # We assume that each process consumes about
297473d5 210 # 128MB of memory. Therefore we find out how
eeee108f 211 # many processes fit into memory.
297473d5 212 local mem_max=$(( ${SYSTEM_MEMORY} / 128 ))
72c39057 213 local cpu_max=$(( ${SYSTEM_PROCESSORS} ))
eeee108f
MT
214
215 local parallelism
216 if [ ${mem_max} -lt ${cpu_max} ]; then
217 parallelism=${mem_max}
218 else
219 parallelism=${cpu_max}
69a6ec55 220 fi
212f17c1 221
eeee108f
MT
222 # Use this as default PARALLELISM
223 DEFAULT_PARALLELISM="${parallelism}"
224
e1616eb4
SS
225 # Limit lauched ninja build jobs to computed parallel value.
226 NINJAJOBS="${parallelism}"
227
212f17c1
MT
228 # Compression parameters
229 # We use mode 8 for reasonable memory usage when decompressing
230 # but with overall good compression
231 XZ_OPT="-8"
232
233 # We try to use as many cores as possible
234 XZ_OPT="${XZ_OPT} -T0"
235
236 # We need to limit memory because XZ uses too much when running
237 # in parallel and it isn't very smart in limiting itself.
238 # We allow XZ to use up to 70% of all system memory.
deffc275 239 local xz_memory=$(( SYSTEM_MEMORY * 7 / 10 ))
212f17c1
MT
240
241 # XZ memory cannot be larger than 2GB on 32 bit systems
242 case "${build_arch}" in
6cf219c4 243 armv*)
212f17c1
MT
244 if [ ${xz_memory} -gt 2048 ]; then
245 xz_memory=2048
246 fi
247 ;;
248 esac
249
250 XZ_OPT="${XZ_OPT} --memory=${xz_memory}MiB"
69a6ec55
MT
251}
252
253configure_build_guess() {
254 case "${HOST_ARCH}" in
87487585
MT
255 x86_64)
256 echo "x86_64"
257 ;;
69a6ec55
MT
258
259 aarch64)
260 echo "aarch64"
261 ;;
262
aafdd71b
AF
263 armv7*|armv6*)
264 echo "armv6l"
69a6ec55
MT
265 ;;
266
161eb15d
MT
267 riscv64)
268 echo "riscv64"
269 ;;
270
69a6ec55
MT
271 *)
272 exiterror "Cannot guess build architecture"
273 ;;
274 esac
275}
276
f9783277
MT
277stdumount() {
278 umount $BASEDIR/build/sys 2>/dev/null;
279 umount $BASEDIR/build/dev/shm 2>/dev/null;
280 umount $BASEDIR/build/dev/pts 2>/dev/null;
281 umount $BASEDIR/build/dev 2>/dev/null;
282 umount $BASEDIR/build/proc 2>/dev/null;
283 umount $BASEDIR/build/install/mnt 2>/dev/null;
284 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
285 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
286 umount $BASEDIR/build/usr/src/config 2>/dev/null;
287 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
288 umount $BASEDIR/build/usr/src/html 2>/dev/null;
289 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
290 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
ebaecf2c 291 umount $BASEDIR/build/usr/src/log 2>/dev/null;
f9783277 292 umount $BASEDIR/build/usr/src/src 2>/dev/null;
7c984de6 293 umount $BASEDIR/build/usr/src 2>/dev/null;
cb658c8c 294 umount $BASEDIR/build/tmp 2>/dev/null;
f9783277
MT
295}
296
297now() {
298 date -u "+%s"
69a6ec55
MT
299}
300
f9783277
MT
301format_runtime() {
302 local seconds=${1}
303
304 if [ ${seconds} -ge 3600 ]; then
305 printf "%d:%02d:%02d\n" \
306 "$(( seconds / 3600 ))" \
307 "$(( seconds % 3600 / 60 ))" \
308 "$(( seconds % 3600 % 60 ))"
309 elif [ ${seconds} -ge 60 ]; then
310 printf "%d:%02d\n" \
311 "$(( seconds / 60 ))" \
312 "$(( seconds % 60 ))"
69a6ec55 313 else
f9783277 314 printf "%d\n" "${seconds}"
69a6ec55 315 fi
f9783277 316}
69a6ec55 317
f9783277
MT
318print_line() {
319 local line="$@"
69a6ec55 320
f9783277 321 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
322}
323
f9783277
MT
324_print_line() {
325 local status="${1}"
326 shift
69a6ec55 327
f9783277
MT
328 if ${INTERACTIVE}; then
329 printf "${!status}"
330 fi
69a6ec55 331
f9783277
MT
332 print_line "$@"
333
334 if ${INTERACTIVE}; then
335 printf "${NORMAL}"
336 fi
337}
338
339print_headline() {
340 _print_line BOLD "$@"
69a6ec55
MT
341}
342
f9783277
MT
343print_error() {
344 _print_line FAIL "$@"
345}
346
347print_package() {
348 local name="${1}"
349 shift
69a6ec55 350
f9783277
MT
351 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
352 local options="$@"
353
354 local string="${name}"
355 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
356 string="${string} (${version})"
357 fi
358
359 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 360 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
361}
362
363print_runtime() {
364 local runtime=$(format_runtime $@)
365
366 if ${INTERACTIVE}; then
367 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
368 else
369 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 370 fi
f9783277
MT
371}
372
373print_status() {
374 local status="${1}"
375
376 local color="${!status}"
377
378 if ${INTERACTIVE}; then
379 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
380 else
381 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 382 fi
f9783277 383}
69a6ec55 384
f9783277
MT
385print_build_stage() {
386 print_headline "$@"
387
388 # end line
389 printf "\n"
69a6ec55
MT
390}
391
f9783277
MT
392print_build_summary() {
393 local runtime=$(format_runtime $@)
394
395 print_line "*** Build finished in ${runtime}"
396 print_status DONE
69a6ec55
MT
397}
398
399exiterror() {
400 stdumount
401 for i in `seq 0 7`; do
402 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
403 losetup -d /dev/loop${i} 2>/dev/null
404 fi;
405 done
406
f9783277 407 # Dump logfile
66028310 408 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
409 echo # empty line
410
411 local line
412 while read -r line; do
413 echo " ${line}"
414 done <<< "$(tail -n30 ${LOGFILE})"
415 fi
416
f9783277
MT
417 echo # empty line
418
419 local line
420 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
421 print_error "${line}"
422 print_status FAIL
423 done
424
69a6ec55
MT
425 exit 1
426}
427
aecbe123
MT
428prepareenv() {
429 # Are we running the right shell?
54328605 430 if [ -z "${BASH}" ]; then
aecbe123
MT
431 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
432 fi
433
434 if [ -z "${BASH_VERSION}" ]; then
435 exiterror "Not running BASH shell."
436 fi
437
438 # Trap on emergency exit
439 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
440
aecbe123 441 # Checking if running as root user
658232a6 442 if [ $(id -u) -ne 0 ]; then
df7f30a1 443 exiterror "root privileges required for building"
aecbe123
MT
444 fi
445
446 # Checking for necessary temporary space
f9783277 447 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
448 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
449 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
450 if (( 2048000 > $BASE_ASPACE )); then
451 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
452 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 453 print_status FAIL
aecbe123
MT
454 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
455 fi
456 else
f9783277 457 print_status DONE
aecbe123
MT
458 fi
459
460 # Set umask
461 umask 022
462
463 # Set LFS Directory
464 LFS=$BASEDIR/build
465
aecbe123
MT
466 # Setup environment
467 set +h
468 LC_ALL=POSIX
e1616eb4 469 export LFS LC_ALL CFLAGS CXXFLAGS DEFAULT_PARALLELISM RUSTFLAGS NINJAJOBS
aecbe123
MT
470 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
471
472 # Make some extra directories
473 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
474 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
475 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
380aa6e5 476 mkdir -p $BASEDIR/{cache,ccache/${BUILD_ARCH}/${TOOLCHAINVER}} 2>/dev/null
7c984de6
MT
477
478 if [ "${ENABLE_RAMDISK}" = "on" ]; then
479 mkdir -p $BASEDIR/build/usr/src
815ca15d 480 mount -t tmpfs tmpfs -o size=8G,nr_inodes=1M,mode=1777 $BASEDIR/build/usr/src
ad853b56
MT
481
482 mkdir -p ${BASEDIR}/build/tmp
483 mount -t tmpfs tmpfs -o size=4G,nr_inodes=1M,mode=1777 ${BASEDIR}/build/tmp
7c984de6
MT
484 fi
485
ebaecf2c 486 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
aecbe123
MT
487
488 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
489 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
490
491 # Make all sources and proc available under lfs build
492 mount --bind /dev $BASEDIR/build/dev
493 mount --bind /dev/pts $BASEDIR/build/dev/pts
494 mount --bind /dev/shm $BASEDIR/build/dev/shm
495 mount --bind /proc $BASEDIR/build/proc
496 mount --bind /sys $BASEDIR/build/sys
497 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
380aa6e5 498 mount --bind $BASEDIR/ccache/${BUILD_ARCH}/${TOOLCHAINVER} $BASEDIR/build/usr/src/ccache
aecbe123
MT
499 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
500 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
501 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
502 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
503 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
ebaecf2c 504 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
aecbe123
MT
505 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
506
507 # Run LFS static binary creation scripts one by one
508 export CCACHE_DIR=$BASEDIR/ccache
36065e42 509 export CCACHE_TEMPDIR="/tmp"
aecbe123
MT
510 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
511
512 # Remove pre-install list of installed files in case user erase some files before rebuild
513 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
514
515 # Prepare string for /etc/system-release.
f48643e5
MT
516 local system_release="${NAME} ${VERSION} (${BUILD_ARCH})"
517
518 case "${GIT_BRANCH}" in
519 core*|beta?|rc?)
520 system_release="${system_release} - ${GIT_BRANCH}"
521 ;;
522 *)
9ff65bfa 523 system_release="${system_release} - core${CORE} Development Build: ${GIT_BRANCH}/${GIT_LASTCOMMIT:0:8}"
f48643e5 524 ;;
aecbe123 525 esac
4e54a8e2 526
f48643e5
MT
527 # Append -dirty tag for local changes
528 if [ "$(git status -s | wc -l)" != "0" ]; then
529 system_release="${system_release}-dirty"
530 fi
531
532 # Export variable
533 SYSTEM_RELEASE="${system_release}"
534
040160c7
MT
535 # Decide on PAKFIRE_TREE
536 case "${GIT_BRANCH}" in
537 core*)
538 PAKFIRE_TREE="stable"
539 ;;
540 master)
541 PAKFIRE_TREE="testing"
542 ;;
543 *)
544 PAKFIRE_TREE="unstable"
545 ;;
546 esac
547
4e54a8e2
MT
548 # Setup ccache cache size
549 enterchroot ccache --max-size="${CCACHE_CACHE_SIZE}" >/dev/null
aecbe123
MT
550}
551
69a6ec55
MT
552enterchroot() {
553 # Install QEMU helper, if needed
554 qemu_install_helper
555
556 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
557
558 PATH="${PATH}" chroot ${LFS} env -i \
559 HOME="/root" \
560 TERM="${TERM}" \
561 PS1="${PS1}" \
562 PATH="${PATH}" \
563 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
040160c7 564 PAKFIRE_TREE="${PAKFIRE_TREE}" \
69a6ec55
MT
565 NAME="${NAME}" \
566 SNAME="${SNAME}" \
567 VERSION="${VERSION}" \
568 CORE="${CORE}" \
569 SLOGAN="${SLOGAN}" \
570 TOOLS_DIR="${TOOLS_DIR}" \
571 CONFIG_ROOT="${CONFIG_ROOT}" \
572 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
573 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
82454983 574 RUSTFLAGS="${RUSTFLAGS}" \
69a6ec55
MT
575 BUILDTARGET="${BUILDTARGET}" \
576 CROSSTARGET="${CROSSTARGET}" \
577 BUILD_ARCH="${BUILD_ARCH}" \
578 BUILD_PLATFORM="${BUILD_PLATFORM}" \
579 CCACHE_DIR=/usr/src/ccache \
36065e42 580 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55 581 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
486112ad 582 GOCACHE="/usr/src/ccache/go" \
69a6ec55 583 KVER="${KVER}" \
0d7a6f03 584 XZ_OPT="${XZ_OPT}" \
77c863a2 585 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
586 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
587 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
588 $(fake_environ) \
589 $(qemu_environ) \
590 "$@"
591}
592
593entershell() {
594 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
595 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
596 fi
597
598 echo "Entering to a shell inside LFS chroot, go out with exit"
ab8464f4 599 local PS1="ipfire build chroot (${BUILD_ARCH}) \u:\w\$ "
69a6ec55
MT
600
601 if enterchroot bash -i; then
602 stdumount
603 else
f9783277 604 print_status FAIL
69a6ec55
MT
605 exiterror "chroot error"
606 fi
607}
608
609lfsmakecommoncheck() {
610 # Script present?
611 if [ ! -f $BASEDIR/lfs/$1 ]; then
612 exiterror "No such file or directory: $BASEDIR/$1"
613 fi
614
f9783277
MT
615 # Print package name and version
616 print_package $@
69a6ec55
MT
617
618 # Check if this package is supported by our architecture.
619 # If no SUP_ARCH is found, we assume the package can be built for all.
620 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
621 # Check if package supports ${BUILD_ARCH} or all architectures.
622 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 623 print_runtime 0
f9783277 624 print_status SKIP
69a6ec55
MT
625 return 1
626 fi
627 fi
628
629 # Script slipped?
630 local i
631 for i in $SKIP_PACKAGE_LIST
632 do
633 if [ "$i" == "$1" ]; then
f9783277 634 print_status SKIP
69a6ec55
MT
635 return 1;
636 fi
637 done
638
639 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
640
641 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
642 MESSAGE="$1\t " download >> $LOGFILE 2>&1
643 if [ $? -ne 0 ]; then
644 exiterror "Download error in $1"
645 fi
646
647 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
648 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
649 if [ $? -ne 0 ]; then
650 exiterror "md5sum error in $1, check file in cache or signature"
651 fi
652
653 return 0 # pass all!
654}
655
656lfsmake1() {
657 lfsmakecommoncheck $*
658 [ $? == 1 ] && return 0
659
69a6ec55
MT
660 cd $BASEDIR/lfs && env -i \
661 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
4301024b 662 CCACHE_DIR="${CCACHE_DIR}"/${BUILD_ARCH}/${TOOLCHAINVER} \
36065e42 663 CCACHE_TEMPDIR="${CCACHE_TEMPDIR}" \
69a6ec55
MT
664 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
665 CFLAGS="${CFLAGS}" \
666 CXXFLAGS="${CXXFLAGS}" \
77c863a2 667 DEFAULT_PARALLELISM="${DEFAULT_PARALLELISM}" \
85560933
MT
668 SYSTEM_PROCESSORS="${SYSTEM_PROCESSORS}" \
669 SYSTEM_MEMORY="${SYSTEM_MEMORY}" \
69a6ec55
MT
670 make -f $* \
671 TOOLCHAIN=1 \
672 TOOLS_DIR="${TOOLS_DIR}" \
673 CROSSTARGET="${CROSSTARGET}" \
674 BUILDTARGET="${BUILDTARGET}" \
675 BUILD_ARCH="${BUILD_ARCH}" \
676 BUILD_PLATFORM="${BUILD_PLATFORM}" \
677 LFS_BASEDIR="${BASEDIR}" \
678 ROOT="${LFS}" \
679 KVER="${KVER}" \
f9783277 680 install >> $LOGFILE 2>&1 &
69a6ec55 681
f9783277
MT
682 if ! wait_until_finished $!; then
683 print_status FAIL
684 exiterror "Building $*"
69a6ec55
MT
685 fi
686
f9783277 687 print_status DONE
69a6ec55
MT
688}
689
690lfsmake2() {
691 lfsmakecommoncheck $*
692 [ $? == 1 ] && return 0
693
69a6ec55
MT
694 local PS1='\u:\w$ '
695
696 enterchroot \
ce9264a1 697 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
698 make -f $* \
699 LFS_BASEDIR=/usr/src install" \
f9783277 700 >> ${LOGFILE} 2>&1 &
69a6ec55 701
f9783277
MT
702 if ! wait_until_finished $!; then
703 print_status FAIL
704 exiterror "Building $*"
69a6ec55
MT
705 fi
706
f9783277 707 print_status DONE
69a6ec55
MT
708}
709
710ipfiredist() {
711 lfsmakecommoncheck $*
712 [ $? == 1 ] && return 0
713
69a6ec55
MT
714 local PS1='\u:\w$ '
715
716 enterchroot \
717 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 718 >> ${LOGFILE} 2>&1 &
69a6ec55 719
f9783277
MT
720 if ! wait_until_finished $!; then
721 print_status FAIL
722 exiterror "Packaging $*"
723 fi
69a6ec55 724
f9783277
MT
725 print_status DONE
726}
727
728wait_until_finished() {
729 local pid=${1}
730
731 local start_time=$(now)
732
733 # Show progress
734 if ${INTERACTIVE}; then
735 # Wait a little just in case the process
736 # has finished very quickly.
737 sleep 0.1
738
739 local runtime
740 while kill -0 ${pid} 2>/dev/null; do
741 print_runtime $(( $(now) - ${start_time} ))
742
743 # Wait a little
744 sleep 1
745 done
69a6ec55 746 fi
f9783277
MT
747
748 # Returns the exit code of the child process
749 wait ${pid}
750 local ret=$?
751
752 if ! ${INTERACTIVE}; then
753 print_runtime $(( $(now) - ${start_time} ))
754 fi
755
756 return ${ret}
69a6ec55
MT
757}
758
759fake_environ() {
760 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
761
762 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
763
764 # Fake kernel version, because some of the packages do not compile
765 # with kernel 3.0 and later.
8634797e 766 env="${env} UTS_RELEASE=${KVER}-ipfire"
69a6ec55
MT
767
768 # Fake machine version.
769 env="${env} UTS_MACHINE=${BUILD_ARCH}"
770
771 echo "${env}"
772}
773
774qemu_environ() {
775 local env
776
777 # Don't add anything if qemu is not used.
778 if ! qemu_is_required; then
779 return
780 fi
781
782 # Set default qemu options
783 case "${BUILD_ARCH}" in
784 arm*)
785 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
786
787 env="${env} QEMU_CPU=${QEMU_CPU}"
788 ;;
789 esac
790
791 # Enable QEMU strace
792 #env="${env} QEMU_STRACE=1"
793
794 echo "${env}"
795}
796
797qemu_is_required() {
798 local build_arch="${1}"
799
800 if [ -z "${build_arch}" ]; then
801 build_arch="${BUILD_ARCH}"
802 fi
803
804 case "${HOST_ARCH},${build_arch}" in
161eb15d 805 x86_64,arm*|x86_64,aarch64|x86_64,riscv64|i?86,arm*|i?86,aarch64|i?86,x86_64)
69a6ec55
MT
806 return 0
807 ;;
808 *)
809 return 1
810 ;;
811 esac
812}
813
814qemu_install_helper() {
815 # Do nothing, if qemu is not required
816 if ! qemu_is_required; then
817 return 0
818 fi
819
820 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
821 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
822 fi
823
824 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
825 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
826 fi
827
828
829 if [ -z "${QEMU_TARGET_HELPER}" ]; then
830 exiterror "QEMU_TARGET_HELPER not set"
831 fi
832
833 # Check if the helper is already installed.
834 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
835 return 0
836 fi
837
838 # Try to find a suitable binary that we can install
839 # to the build environment.
840 local file
841 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
842 # file must exist and be executable.
843 [ -x "${file}" ] || continue
844
845 # Must be static.
846 file_is_static "${file}" || continue
847
848 local dirname="${LFS}$(dirname "${file}")"
849 mkdir -p "${dirname}"
850
851 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
852 return 0
853 done
854
855 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
856}
857
858qemu_find_build_helper_name() {
859 local build_arch="${1}"
860
861 local magic
862 case "${build_arch}" in
0db0f7fa
AF
863 aarch64)
864 magic="7f454c460201010000000000000000000200b700"
865 ;;
4576ca4c
MT
866 arm*)
867 magic="7f454c4601010100000000000000000002002800"
868 ;;
161eb15d
MT
869 riscv64)
870 magic="7f454c460201010000000000000000000200f300"
871 ;;
69a6ec55
MT
872 x86_64)
873 magic="7f454c4602010100000000000000000002003e00"
874 ;;
875 esac
876
877 [ -z "${magic}" ] && return 1
878
879 local file
880 for file in /proc/sys/fs/binfmt_misc/*; do
881 # skip write only register entry
882 [ $(basename "${file}") = "register" ] && continue
883 # Search for the file with the correct magic value.
884 grep -qE "^magic ${magic}$" "${file}" || continue
885
886 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
887
888 [ -n "${interpreter}" ] || continue
889 [ "${interpreter:0:1}" = "/" ] || continue
890 [ -x "${interpreter}" ] || continue
891
892 echo "${interpreter}"
893 return 0
894 done
895
896 return 1
897}
898
899file_is_static() {
900 local file="${1}"
901
902 file ${file} 2>/dev/null | grep -q "statically linked"
903}
904
905update_language_list() {
906 local path="${1}"
907
908 local lang
909 for lang in ${path}/*.po; do
910 lang="$(basename "${lang}")"
911 echo "${lang%*.po}"
912 done | sort -u > "${path}/LINGUAS"
913}
914
1fb7f56e
MT
915contributors() {
916 local commits name
917
918 git shortlog --summary --numbered | while read -r commits name; do
919 echo "${name}"
920 done | grep -vE -e "^(alpha197|morlix|root|ummeegge)$" -e "via Development$" -e "@" -e "#$"
921}
922
923update_contributors() {
924 echo -n "Updating list of contributors"
925
926 local contributors="$(contributors | paste -sd , - | sed -e "s/,/&\\\\n/g")"
927
928 # Edit contributors into credits.cgi
e2338aa7
MT
929 local tmp="$(mktemp)"
930
931 awk "/<!-- CONTRIBUTORS -->/{ p=1; print; printf \"${contributors}\n\"}/<!-- END -->/{ p=0 } !p" \
932 < "${BASEDIR}/html/cgi-bin/credits.cgi" > "${tmp}"
933
934 # Copy back modified content
935 cat "${tmp}" > "${BASEDIR}/html/cgi-bin/credits.cgi"
936 unlink "${tmp}"
1fb7f56e
MT
937
938 print_status DONE
939 return 0
940}
941
15b005d8 942# Default settings
99597de7 943CCACHE_CACHE_SIZE="4G"
15b005d8
MT
944ENABLE_RAMDISK="auto"
945
a98ab1d7
MT
946# Load configuration file
947if [ -f .config ]; then
948 . .config
949fi
950
813659f2
MT
951# TARGET_ARCH is BUILD_ARCH now
952if [ -n "${TARGET_ARCH}" ]; then
953 BUILD_ARCH="${TARGET_ARCH}"
954 unset TARGET_ARCH
955fi
956
85560933
MT
957# Get some information about the host system
958SYSTEM_PROCESSORS="$(system_processors)"
959SYSTEM_MEMORY="$(system_memory)"
960
dc7d6b20
MT
961if [ -n "${BUILD_ARCH}" ]; then
962 configure_build "${BUILD_ARCH}"
949544f5 963else
dc7d6b20 964 configure_build "default"
949544f5
MT
965fi
966
15b005d8
MT
967# Automatically enable/disable ramdisk usage
968if [ "${ENABLE_RAMDISK}" = "auto" ]; then
969 # Enable only when the host system has 4GB of RAM or more
970 if [ ${SYSTEM_MEMORY} -ge 3900 ]; then
971 ENABLE_RAMDISK="on"
972 fi
973fi
974
df5e82b3 975buildtoolchain() {
69a6ec55
MT
976 local error=false
977 case "${BUILD_ARCH}:${HOST_ARCH}" in
978 # x86_64
979 x86_64:x86_64)
980 # This is working.
981 ;;
982
69a6ec55
MT
983 # ARM
984 arvm7hl:armv7hl|armv7hl:armv7l)
985 # These are working.
986 ;;
987
aafdd71b 988 armv6l:armv6l|armv6l:armv7l|armv6l:aarch64)
69a6ec55
MT
989 # These are working.
990 ;;
aafdd71b 991 armv6l:*)
69a6ec55
MT
992 error=true
993 ;;
994 esac
995
996 ${error} && \
997 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
998
999 local gcc=$(type -p gcc)
1000 if [ -z "${gcc}" ]; then
1001 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
1002 fi
1003
6bd3a131
MT
1004 # Check ${TOOLS_DIR} symlink
1005 if [ -h "${TOOLS_DIR}" ]; then
1006 rm -f "${TOOLS_DIR}"
1007 fi
1008
1009 if [ ! -e "${TOOLS_DIR}" ]; then
1010 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
1011 fi
1012
1013 if [ ! -h "${TOOLS_DIR}" ]; then
1014 exiterror "Could not create ${TOOLS_DIR} symbolic link"
1015 fi
1016
ebaecf2c 1017 LOGFILE="$BASEDIR/log/_build.toolchain.log"
69a6ec55
MT
1018 export LOGFILE
1019
1020 lfsmake1 stage1
69a6ec55
MT
1021 lfsmake1 binutils PASS=1
1022 lfsmake1 gcc PASS=1
1023 lfsmake1 linux KCFG="-headers"
1024 lfsmake1 glibc
178c7a6a 1025 lfsmake1 libxcrypt
69a6ec55 1026 lfsmake1 gcc PASS=L
54d54148 1027 lfsmake1 zlib
2d29899d 1028 lfsmake1 zstd
7d14c775
MT
1029 lfsmake1 binutils PASS=2
1030 lfsmake1 gcc PASS=2
74ee1c7a 1031 lfsmake1 ccache
69a6ec55
MT
1032 lfsmake1 tcl
1033 lfsmake1 expect
1034 lfsmake1 dejagnu
1035 lfsmake1 pkg-config
1036 lfsmake1 ncurses
1037 lfsmake1 bash
1038 lfsmake1 bzip2
1039 lfsmake1 automake
1040 lfsmake1 coreutils
1041 lfsmake1 diffutils
1042 lfsmake1 findutils
1043 lfsmake1 gawk
1044 lfsmake1 gettext
1045 lfsmake1 grep
1046 lfsmake1 gzip
1047 lfsmake1 m4
1048 lfsmake1 make
1049 lfsmake1 patch
1050 lfsmake1 perl
46bbc13b 1051 lfsmake1 python3
69a6ec55
MT
1052 lfsmake1 sed
1053 lfsmake1 tar
1054 lfsmake1 texinfo
1055 lfsmake1 xz
85439ac7 1056 lfsmake1 bison
11b5e5cb 1057 lfsmake1 flex
69a6ec55 1058 lfsmake1 fake-environ
7b93b62b 1059 lfsmake1 strip
69a6ec55 1060 lfsmake1 cleanup-toolchain
df5e82b3
MT
1061}
1062
1063buildbase() {
ebaecf2c 1064 LOGFILE="$BASEDIR/log/_build.base.log"
69a6ec55
MT
1065 export LOGFILE
1066 lfsmake2 stage2
1067 lfsmake2 linux KCFG="-headers"
1068 lfsmake2 man-pages
1069 lfsmake2 glibc
1070 lfsmake2 tzdata
1071 lfsmake2 cleanup-toolchain
1072 lfsmake2 zlib
b14c24ca 1073 lfsmake2 zstd
cf6c8e67
MT
1074 lfsmake2 autoconf
1075 lfsmake2 automake
1076 lfsmake2 libtool
69a6ec55
MT
1077 lfsmake2 binutils
1078 lfsmake2 gmp
69a6ec55
MT
1079 lfsmake2 mpfr
1080 lfsmake2 libmpc
cf6c8e67 1081 lfsmake2 libxcrypt
69a6ec55
MT
1082 lfsmake2 file
1083 lfsmake2 gcc
1084 lfsmake2 sed
69a6ec55
MT
1085 lfsmake2 berkeley
1086 lfsmake2 coreutils
1087 lfsmake2 iana-etc
1088 lfsmake2 m4
1089 lfsmake2 bison
69a6ec55 1090 lfsmake2 ncurses
69a6ec55
MT
1091 lfsmake2 perl
1092 lfsmake2 readline
69a6ec55 1093 lfsmake2 bzip2
3ece7859 1094 lfsmake2 xz
f407f05a 1095 lfsmake2 lzip
69a6ec55 1096 lfsmake2 pcre
b0c37190 1097 lfsmake2 pcre2
d701756a 1098 lfsmake2 gettext
241bf919
MT
1099 lfsmake2 attr
1100 lfsmake2 acl
69a6ec55
MT
1101 lfsmake2 bash
1102 lfsmake2 diffutils
69a6ec55
MT
1103 lfsmake2 ed
1104 lfsmake2 findutils
1105 lfsmake2 flex
1106 lfsmake2 gawk
d2315d00 1107 lfsmake2 go
69a6ec55
MT
1108 lfsmake2 grep
1109 lfsmake2 groff
1110 lfsmake2 gperf
1111 lfsmake2 gzip
1112 lfsmake2 hostname
ac36f9f2 1113 lfsmake2 whois
69a6ec55
MT
1114 lfsmake2 kbd
1115 lfsmake2 less
4720fa0d 1116 lfsmake2 pkg-config
50992c73 1117 lfsmake2 procps
69a6ec55
MT
1118 lfsmake2 make
1119 lfsmake2 man
69a6ec55
MT
1120 lfsmake2 net-tools
1121 lfsmake2 patch
1122 lfsmake2 psmisc
1123 lfsmake2 shadow
1124 lfsmake2 sysklogd
1125 lfsmake2 sysvinit
1126 lfsmake2 tar
1127 lfsmake2 texinfo
1128 lfsmake2 util-linux
69a6ec55 1129 lfsmake2 vim
69b3d63b 1130 lfsmake2 e2fsprogs
df5e82b3
MT
1131}
1132
15679d9f 1133buildipfire() {
ebaecf2c 1134 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1135 export LOGFILE
489145db
MT
1136 lfsmake2 configroot
1137 lfsmake2 initscripts
1138 lfsmake2 backup
c38f55fe 1139 lfsmake2 openssl
1ece41ec 1140 lfsmake2 kmod
e1c6cd05 1141 lfsmake2 udev
3755e358 1142 lfsmake2 popt
d4767896 1143 lfsmake2 libedit
489145db
MT
1144 lfsmake2 libusb
1145 lfsmake2 libusb-compat
1146 lfsmake2 libpcap
1147 lfsmake2 ppp
1148 lfsmake2 pptp
1149 lfsmake2 unzip
1150 lfsmake2 which
1151 lfsmake2 linux-firmware
489145db 1152 lfsmake2 dvb-firmwares
37b86fa9 1153 lfsmake2 xr819-firmware
489145db
MT
1154 lfsmake2 zd1211-firmware
1155 lfsmake2 rpi-firmware
26796f3a 1156 lfsmake2 intel-microcode
0e54ca26 1157 lfsmake2 pcengines-apu-firmware
489145db 1158 lfsmake2 bc
2a0947f2 1159 lfsmake2 u-boot MKIMAGE=1
489145db
MT
1160 lfsmake2 cpio
1161 lfsmake2 mdadm
1162 lfsmake2 dracut
de18b4de 1163 lfsmake2 libaio
489145db
MT
1164 lfsmake2 lvm2
1165 lfsmake2 multipath-tools
1166 lfsmake2 freetype
489145db
MT
1167 lfsmake2 libmnl
1168 lfsmake2 libnfnetlink
1169 lfsmake2 libnetfilter_queue
1170 lfsmake2 libnetfilter_conntrack
1171 lfsmake2 libnetfilter_cthelper
1172 lfsmake2 libnetfilter_cttimeout
1173 lfsmake2 iptables
66bc17dc 1174 lfsmake2 iproute2
0245f3b6 1175 lfsmake2 screen
54ead8ef 1176 lfsmake2 elfutils
8e6fb99d 1177
efafef16
AF
1178 # Kernelbuild ... current we have no platform that need
1179 # multi kernel builds so KCFG is empty
1180 lfsmake2 linux KCFG=""
1181 lfsmake2 rtl8189es KCFG=""
1182 lfsmake2 rtl8812au KCFG=""
8bb80576 1183 lfsmake2 rtl8822bu KCFG=""
efafef16
AF
1184 lfsmake2 xradio KCFG=""
1185 lfsmake2 xtables-addons KCFG=""
1186 lfsmake2 linux-initrd KCFG=""
1187
1188 lfsmake2 xtables-addons USPACE="1"
489145db
MT
1189 lfsmake2 libgpg-error
1190 lfsmake2 libgcrypt
1191 lfsmake2 libassuan
1192 lfsmake2 nettle
1a7db134 1193 lfsmake2 json-c
f3e62301 1194 lfsmake2 libconfig
489145db
MT
1195 lfsmake2 libevent
1196 lfsmake2 libevent2
1197 lfsmake2 expat
c8e9a7a8
WA
1198 lfsmake2 apr
1199 lfsmake2 aprutil
489145db
MT
1200 lfsmake2 unbound
1201 lfsmake2 gnutls
689246f5 1202 lfsmake2 libuv
489145db
MT
1203 lfsmake2 bind
1204 lfsmake2 dhcp
1205 lfsmake2 dhcpcd
1206 lfsmake2 boost
1207 lfsmake2 linux-atm
1208 lfsmake2 gdbm
1209 lfsmake2 pam
d44ce7d4 1210 lfsmake2 c-ares
489145db
MT
1211 lfsmake2 curl
1212 lfsmake2 tcl
1213 lfsmake2 sqlite
1214 lfsmake2 libffi
489145db 1215 lfsmake2 python3
8a4495a4 1216 lfsmake2 gdb
b3ce3510
MT
1217 lfsmake2 grub
1218 lfsmake2 efivar
1219 lfsmake2 efibootmgr
40cdf896
AB
1220 lfsmake2 libtasn1
1221 lfsmake2 p11-kit
489145db
MT
1222 lfsmake2 ca-certificates
1223 lfsmake2 fireinfo
1224 lfsmake2 libnet
1225 lfsmake2 libnl
1226 lfsmake2 libnl-3
1227 lfsmake2 libidn
1228 lfsmake2 nasm
4f516b87
MF
1229 lfsmake2 libarchive
1230 lfsmake2 cmake
814a33ff
SS
1231 lfsmake2 ninja
1232 lfsmake2 meson
489145db 1233 lfsmake2 libjpeg
58d965fe 1234 lfsmake2 openjpeg
489145db
MT
1235 lfsmake2 libexif
1236 lfsmake2 libpng
1237 lfsmake2 libtiff
1238 lfsmake2 libart
1239 lfsmake2 gd
489145db
MT
1240 lfsmake2 slang
1241 lfsmake2 newt
1242 lfsmake2 libsmooth
489145db 1243 lfsmake2 libcap
b051eb68 1244 lfsmake2 libcap-ng
489145db
MT
1245 lfsmake2 pciutils
1246 lfsmake2 usbutils
1247 lfsmake2 libxml2
1248 lfsmake2 libxslt
1249 lfsmake2 BerkeleyDB
489145db
MT
1250 lfsmake2 cyrus-sasl
1251 lfsmake2 openldap
1252 lfsmake2 apache2
489145db
MT
1253 lfsmake2 web-user-interface
1254 lfsmake2 flag-icons
1255 lfsmake2 jquery
6033b271 1256 lfsmake2 bootstrap
489145db
MT
1257 lfsmake2 arping
1258 lfsmake2 beep
1df47cc9 1259 lfsmake2 libssh
ff075def 1260 lfsmake2 libinih
8a960584 1261 lfsmake2 cdrkit
489145db 1262 lfsmake2 dosfstools
574690dc 1263 lfsmake2 exfatprogs
489145db 1264 lfsmake2 reiserfsprogs
14192b69 1265 lfsmake2 liburcu
489145db
MT
1266 lfsmake2 xfsprogs
1267 lfsmake2 sysfsutils
1268 lfsmake2 fuse
1269 lfsmake2 ntfs-3g
1270 lfsmake2 ethtool
489145db 1271 lfsmake2 fcron
6cdc5164 1272 lfsmake2 ExtUtils-PkgConfig
489145db
MT
1273 lfsmake2 perl-GD
1274 lfsmake2 GD-Graph
1275 lfsmake2 GD-TextUtil
1276 lfsmake2 perl-Device-SerialPort
1277 lfsmake2 perl-Device-Modem
1278 lfsmake2 perl-Apache-Htpasswd
bbcaca56 1279 lfsmake2 perl-Parse-Yapp
46426b69 1280 lfsmake2 perl-Data-UUID
489145db
MT
1281 lfsmake2 gnupg
1282 lfsmake2 hdparm
1283 lfsmake2 sdparm
489145db 1284 lfsmake2 whatmask
29370584 1285 lfsmake2 libtirpc
489145db 1286 lfsmake2 conntrack-tools
489145db
MT
1287 lfsmake2 iputils
1288 lfsmake2 l7-protocols
489145db
MT
1289 lfsmake2 hwdata
1290 lfsmake2 logrotate
1291 lfsmake2 logwatch
1292 lfsmake2 misc-progs
1293 lfsmake2 nano
1294 lfsmake2 URI
294aa009
AF
1295 lfsmake2 perl-CGI
1296 lfsmake2 perl-Switch
489145db
MT
1297 lfsmake2 HTML-Tagset
1298 lfsmake2 HTML-Parser
1299 lfsmake2 HTML-Template
1300 lfsmake2 Compress-Zlib
1301 lfsmake2 Digest
1302 lfsmake2 Digest-SHA1
1303 lfsmake2 Digest-HMAC
976b84cc 1304 lfsmake2 perl-libwww
489145db
MT
1305 lfsmake2 Net-DNS
1306 lfsmake2 Net-IPv4Addr
1307 lfsmake2 Net_SSLeay
1308 lfsmake2 IO-Stringy
1309 lfsmake2 IO-Socket-SSL
1310 lfsmake2 Unix-Syslog
1311 lfsmake2 Mail-Tools
1312 lfsmake2 MIME-Tools
1313 lfsmake2 Net-Server
a7492c0f 1314 lfsmake2 Canary-Stability
489145db
MT
1315 lfsmake2 Convert-TNEF
1316 lfsmake2 Convert-UUlib
1317 lfsmake2 Archive-Tar
1318 lfsmake2 Archive-Zip
1319 lfsmake2 Text-Tabs+Wrap
489145db
MT
1320 lfsmake2 XML-Parser
1321 lfsmake2 Crypt-PasswdMD5
1322 lfsmake2 Net-Telnet
398669f7 1323 lfsmake2 python3-setuptools
d55a968a 1324 lfsmake2 python3-inotify
05fed717 1325 lfsmake2 python3-docutils
0882b3e4 1326 lfsmake2 python3-daemon
489145db 1327 lfsmake2 glib
489145db
MT
1328 lfsmake2 ntp
1329 lfsmake2 openssh
1330 lfsmake2 fontconfig
1331 lfsmake2 dejavu-fonts-ttf
70f6cba4 1332 lfsmake2 ubuntu-font-family
489145db
MT
1333 lfsmake2 freefont
1334 lfsmake2 pixman
1335 lfsmake2 cairo
0de1daf3
AB
1336 lfsmake2 harfbuzz
1337 lfsmake2 fribidi
489145db
MT
1338 lfsmake2 pango
1339 lfsmake2 rrdtool
489145db
MT
1340 lfsmake2 setup
1341 lfsmake2 libdnet
59fe9735 1342 lfsmake2 rust
616395f3 1343 lfsmake2 jansson
91cc908f 1344 lfsmake2 yaml
3498300d 1345 lfsmake2 libhtp
1a5f0649 1346 lfsmake2 colm
2348cfff 1347 lfsmake2 ragel
52ebc66b 1348 lfsmake2 hyperscan
67752a95 1349 lfsmake2 suricata
489145db 1350 lfsmake2 oinkmaster
ef640882 1351 lfsmake2 ids-ruleset-sources
489145db
MT
1352 lfsmake2 squid
1353 lfsmake2 squidguard
1354 lfsmake2 calamaris
1355 lfsmake2 tcpdump
1356 lfsmake2 traceroute
1357 lfsmake2 vlan
1358 lfsmake2 wireless
1359 lfsmake2 pakfire
1360 lfsmake2 spandsp
adf3f4f4 1361 lfsmake2 lz4
489145db
MT
1362 lfsmake2 lzo
1363 lfsmake2 openvpn
489145db
MT
1364 lfsmake2 mpage
1365 lfsmake2 dbus
1366 lfsmake2 intltool
1367 lfsmake2 libdaemon
6064cd87 1368 lfsmake2 avahi
489145db 1369 lfsmake2 cups
489145db 1370 lfsmake2 lcms2
56170c2a 1371 lfsmake2 ghostscript
489145db
MT
1372 lfsmake2 qpdf
1373 lfsmake2 poppler
d3dabd4b 1374 lfsmake2 poppler-data
489145db
MT
1375 lfsmake2 cups-filters
1376 lfsmake2 epson-inkjet-printer-escpr
1377 lfsmake2 foomatic
1378 lfsmake2 hplip
1379 lfsmake2 cifs-utils
1380 lfsmake2 krb5
95849177 1381 lfsmake2 rpcsvc-proto
489145db 1382 lfsmake2 samba
18d000c4 1383 lfsmake2 netatalk
489145db
MT
1384 lfsmake2 sudo
1385 lfsmake2 mc
1386 lfsmake2 wget
1387 lfsmake2 bridge-utils
489145db
MT
1388 lfsmake2 smartmontools
1389 lfsmake2 htop
1390 lfsmake2 chkconfig
1391 lfsmake2 postfix
1392 lfsmake2 fetchmail
489145db 1393 lfsmake2 clamav
294aa009 1394 lfsmake2 perl-NetAddr-IP
489145db
MT
1395 lfsmake2 dma
1396 lfsmake2 alsa
1397 lfsmake2 mpfire
1398 lfsmake2 guardian
1399 lfsmake2 libid3tag
1400 lfsmake2 libmad
1401 lfsmake2 libogg
1402 lfsmake2 libvorbis
489145db
MT
1403 lfsmake2 flac
1404 lfsmake2 lame
1405 lfsmake2 sox
41f8d642 1406 lfsmake2 soxr
489145db
MT
1407 lfsmake2 libshout
1408 lfsmake2 xvid
1409 lfsmake2 libmpeg2
489145db
MT
1410 lfsmake2 gnump3d
1411 lfsmake2 rsync
489145db 1412 lfsmake2 rpcbind
14fb55a5 1413 lfsmake2 keyutils
8af744bc 1414 lfsmake2 libnfsidmap
489145db
MT
1415 lfsmake2 nfs
1416 lfsmake2 gnu-netcat
1417 lfsmake2 ncat
1418 lfsmake2 nmap
489145db
MT
1419 lfsmake2 etherwake
1420 lfsmake2 bwm-ng
1421 lfsmake2 sysstat
489145db
MT
1422 lfsmake2 strongswan
1423 lfsmake2 rng-tools
1424 lfsmake2 lsof
1425 lfsmake2 br2684ctl
1426 lfsmake2 pcmciautils
1427 lfsmake2 lm_sensors
25f26fb6 1428 lfsmake2 libstatgrab
489145db
MT
1429 lfsmake2 liboping
1430 lfsmake2 collectd
1431 lfsmake2 elinks
1432 lfsmake2 igmpproxy
489145db 1433 lfsmake2 opus
495cf3e0 1434 lfsmake2 python3-pyparsing
489145db
MT
1435 lfsmake2 spice-protocol
1436 lfsmake2 spice
15c01e30 1437 lfsmake2 sdl2
489145db 1438 lfsmake2 libusbredir
43c3a386 1439 lfsmake2 libseccomp
489145db 1440 lfsmake2 qemu
489145db 1441 lfsmake2 netpbm
489145db 1442 lfsmake2 netsnmpd
489145db 1443 lfsmake2 nagios_nrpe
2af354c2 1444 lfsmake2 nagios-plugins
489145db 1445 lfsmake2 icinga
01c2ea6b 1446 lfsmake2 observium-agent
489145db 1447 lfsmake2 ebtables
489145db 1448 lfsmake2 faad2
e91ceed6 1449 lfsmake2 alac
489145db
MT
1450 lfsmake2 ffmpeg
1451 lfsmake2 vdr
1452 lfsmake2 vdr_streamdev
489145db
MT
1453 lfsmake2 vdr_epgsearch
1454 lfsmake2 vdr_dvbapi
1455 lfsmake2 vdr_eepg
1456 lfsmake2 w_scan
489145db
MT
1457 lfsmake2 mpd
1458 lfsmake2 libmpdclient
1459 lfsmake2 mpc
985741db 1460 lfsmake2 perl-Net-CIDR-Lite
489145db
MT
1461 lfsmake2 perl-Net-SMTP-SSL
1462 lfsmake2 perl-MIME-Base64
1463 lfsmake2 perl-Authen-SASL
1464 lfsmake2 perl-MIME-Lite
1465 lfsmake2 perl-Email-Date-Format
1466 lfsmake2 git
1467 lfsmake2 squidclamav
1468 lfsmake2 vnstat
1469 lfsmake2 iw
1470 lfsmake2 wpa_supplicant
1471 lfsmake2 hostapd
489145db
MT
1472 lfsmake2 syslinux
1473 lfsmake2 tftpd
1474 lfsmake2 cpufrequtils
489145db
MT
1475 lfsmake2 gutenprint
1476 lfsmake2 apcupsd
67fbd255 1477 lfsmake2 fireperf
489145db
MT
1478 lfsmake2 iperf
1479 lfsmake2 iperf3
1480 lfsmake2 7zip
1481 lfsmake2 lynis
489145db
MT
1482 lfsmake2 sshfs
1483 lfsmake2 taglib
489145db
MT
1484 lfsmake2 sslh
1485 lfsmake2 perl-gettext
1486 lfsmake2 perl-Sort-Naturally
1487 lfsmake2 vdradmin
489145db 1488 lfsmake2 perl-DBI
489145db
MT
1489 lfsmake2 perl-DBD-SQLite
1490 lfsmake2 perl-File-ReadBackwards
489145db 1491 lfsmake2 openvmtools
489145db
MT
1492 lfsmake2 joe
1493 lfsmake2 monit
1494 lfsmake2 nut
1495 lfsmake2 watchdog
1496 lfsmake2 libpri
489145db
MT
1497 lfsmake2 usb_modeswitch
1498 lfsmake2 usb_modeswitch_data
1499 lfsmake2 zerofree
489145db
MT
1500 lfsmake2 minicom
1501 lfsmake2 ddrescue
489145db
MT
1502 lfsmake2 powertop
1503 lfsmake2 parted
1504 lfsmake2 swig
4c59cad1 1505 lfsmake2 dtc
2a0947f2 1506 lfsmake2 u-boot
6836e528 1507 lfsmake2 u-boot-friendlyarm
489145db 1508 lfsmake2 wireless-regdb
489145db 1509 lfsmake2 libsolv
489145db 1510 lfsmake2 ddns
662b2a81 1511 lfsmake2 python3-setuptools-scm
5996c281 1512 lfsmake2 python3-six
e0a05a80 1513 lfsmake2 python3-dateutil
d48ea6b5 1514 lfsmake2 python3-jmespath
a33ca4cc 1515 lfsmake2 python3-colorama
d2da17a1 1516 lfsmake2 python3-yaml
953f6f73 1517 lfsmake2 python3-s3transfer
d45d5247 1518 lfsmake2 python3-rsa
faa5472a 1519 lfsmake2 python3-pyasn1
05be1c64 1520 lfsmake2 python3-urllib3
4ab80c5d 1521 lfsmake2 python3-botocore
def9f4a3 1522 lfsmake2 python3-msgpack
280ee7e7 1523 lfsmake2 aws-cli
489145db 1524 lfsmake2 transmission
489145db 1525 lfsmake2 mtr
489145db
MT
1526 lfsmake2 minidlna
1527 lfsmake2 acpid
1528 lfsmake2 fping
1529 lfsmake2 telnet
1530 lfsmake2 xinetd
489145db 1531 lfsmake2 stress
489145db 1532 lfsmake2 sarg
489145db 1533 lfsmake2 nginx
489145db
MT
1534 lfsmake2 sysbench
1535 lfsmake2 strace
489145db
MT
1536 lfsmake2 ltrace
1537 lfsmake2 ipfire-netboot
1538 lfsmake2 lcdproc
489145db
MT
1539 lfsmake2 keepalived
1540 lfsmake2 ipvsadm
1541 lfsmake2 perl-Carp-Clan
1542 lfsmake2 perl-Date-Calc
1543 lfsmake2 perl-Date-Manip
1544 lfsmake2 perl-File-Tail
1545 lfsmake2 perl-TimeDate
1546 lfsmake2 swatch
1547 lfsmake2 tor
489145db
MT
1548 lfsmake2 wavemon
1549 lfsmake2 iptraf-ng
1550 lfsmake2 iotop
1551 lfsmake2 stunnel
489145db 1552 lfsmake2 bacula
b62c826f
MT
1553 lfsmake2 perl-Font-TTF
1554 lfsmake2 perl-IO-String
489145db
MT
1555 lfsmake2 perl-PDF-API2
1556 lfsmake2 squid-accounting
1557 lfsmake2 pigz
1558 lfsmake2 tmux
1559 lfsmake2 perl-Text-CSV_XS
09b09b85 1560 lfsmake2 lua
489145db
MT
1561 lfsmake2 haproxy
1562 lfsmake2 ipset
489145db
MT
1563 lfsmake2 dnsdist
1564 lfsmake2 bird
8c855a58 1565 lfsmake2 libyang
1a7db134 1566 lfsmake2 frr
489145db
MT
1567 lfsmake2 dmidecode
1568 lfsmake2 mcelog
489145db
MT
1569 lfsmake2 libpciaccess
1570 lfsmake2 libyajl
1571 lfsmake2 libvirt
42fca290 1572 lfsmake2 libtalloc
489145db
MT
1573 lfsmake2 freeradius
1574 lfsmake2 perl-common-sense
1575 lfsmake2 perl-inotify2
1576 lfsmake2 perl-Net-IP
0d6cc79d 1577 lfsmake2 wio
773caa66 1578 lfsmake2 iftop
ddcd60f7 1579 lfsmake2 mdns-repeater
429af178 1580 lfsmake2 i2c-tools
4e9000b4 1581 lfsmake2 nss-myhostname
014b235a 1582 lfsmake2 dehydrated
c708fa15 1583 lfsmake2 shairport-sync
46114d79 1584 lfsmake2 borgbackup
50483167 1585 lfsmake2 lmdb
2397e513 1586 lfsmake2 knot
e1982c69 1587 lfsmake2 spectre-meltdown-checker
06fc6170 1588 lfsmake2 zabbix_agentd
82d176d3 1589 lfsmake2 flashrom
2aca6aa0 1590 lfsmake2 firmware-update
ffcef39d 1591 lfsmake2 tshark
9875e9f2 1592 lfsmake2 speedtest-cli
0db643ce 1593 lfsmake2 rfkill
44cc9a3d 1594 lfsmake2 amazon-ssm-agent
d938509e 1595 lfsmake2 libloc
4d275bcd 1596 lfsmake2 ncdu
76c5f3e0 1597 lfsmake2 lshw
68fbcc0e 1598 lfsmake2 socat
7300386b
AB
1599 lfsmake2 libcdada
1600 lfsmake2 pmacct
2b591415 1601 lfsmake2 squid-asnbl
d0817963 1602}
df5e82b3
MT
1603
1604buildinstaller() {
1605 # Run installer scripts one by one
ebaecf2c 1606 LOGFILE="$BASEDIR/log/_build.installer.log"
df5e82b3 1607 export LOGFILE
489145db
MT
1608 lfsmake2 memtest
1609 lfsmake2 installer
ce9264a1
AF
1610 # use toolchain bash for chroot to strip
1611 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1612}
1613
1614buildpackages() {
ebaecf2c 1615 LOGFILE="$BASEDIR/log/_build.packages.log"
df5e82b3
MT
1616 export LOGFILE
1617 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1618
df5e82b3
MT
1619
1620 # Generating list of packages used
dc4ae0b7 1621 print_line "Generating packages list from logs"
df5e82b3 1622 rm -f $BASEDIR/doc/packages-list
ebaecf2c
AF
1623 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1624 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1625 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1626 fi
1627 done
7471f6ab 1628 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1629 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1630 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1631 rm -f $BASEDIR/doc/packages-list
c9673262 1632 # packages-list.txt is ready to be displayed for wiki page
f9783277 1633 print_status DONE
4b06f504
MT
1634
1635 # Update changelog
e49f7f0d 1636 cd $BASEDIR
c43b07fd
AF
1637 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1638 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1639 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1640
9607771a 1641 # Create images for install
489145db 1642 lfsmake2 cdrom
bada0832 1643
4dc82852 1644 # Check if there is a loop device for building in virtual environments
841663e7
MT
1645 modprobe loop 2>/dev/null
1646 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db 1647 lfsmake2 flash-images
4dc82852 1648 fi
c9673262 1649
c4dd9dfc 1650 mv $LFS/install/images/{*.iso,*.img.xz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1651
0d909a4a 1652 ipfirepackages
e67a57fe 1653
b307417f 1654 cd $BASEDIR
744a04ea 1655
aafdd71b
AF
1656 # remove not useable iso on armv6l (needed to build flash images)
1657 [ "${BUILD_ARCH}" = "armv6l" ] && rm -rf *.iso
744a04ea 1658
5336aaa6 1659 for i in $(ls *.bz2 *.img.xz *.iso 2>/dev/null); do
b307417f
AF
1660 md5sum $i > $i.md5
1661 done
1662 cd $PWD
1663
e67a57fe
MT
1664 # Cleanup
1665 stdumount
1666 rm -rf $BASEDIR/build/tmp/*
1667
e67a57fe 1668 cd $PWD
e67a57fe
MT
1669}
1670
1671ipfirepackages() {
489145db 1672 lfsmake2 core-updates
5596077b
MT
1673
1674 local i
dc7d6b20 1675 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1676 i=$(basename ${i})
453b418b
MT
1677 if [ -e $BASEDIR/lfs/$i ]; then
1678 ipfiredist $i
1679 else
1680 echo -n $i
f9783277 1681 print_status SKIP
453b418b 1682 fi
fe7fe395 1683 done
78331e30 1684 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1685 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1686 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1687}
1688
bcb9dc13
MT
1689while [ $# -gt 0 ]; do
1690 case "${1}" in
1691 --target=*)
c2e810de 1692 configure_build "${1#--target=}"
bcb9dc13
MT
1693 ;;
1694 -*)
1695 exiterror "Unknown configuration option: ${1}"
1696 ;;
1697 *)
1698 # Found a command, so exit options parsing.
1699 break
1700 ;;
1701 esac
1702 shift
1703done
1704
df5e82b3
MT
1705# See what we're supposed to do
1706case "$1" in
1707build)
f9783277
MT
1708 START_TIME=$(now)
1709
1710 # Clear screen
1711 ${INTERACTIVE} && clear
1712
d66e6fa8 1713 PACKAGE="$BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst"
df5e82b3 1714 #only restore on a clean disk
6c4cc7ea 1715 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1716 if [ ! -n "$PACKAGE" ]; then
f9783277 1717 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1718 prepareenv
1719 buildtoolchain
1720 else
d66e6fa8 1721 PACKAGENAME=${PACKAGE%.tar.zst}
f9783277 1722 print_build_stage "Packaged toolchain compilation"
df5e82b3 1723 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
cec532b4 1724 zstd -d < "${PACKAGE}" | tar x
df5e82b3
MT
1725 prepareenv
1726 else
1727 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1728 fi
1729 fi
1730 else
df5e82b3
MT
1731 prepareenv
1732 fi
5cfe86e6 1733
f9783277 1734 print_build_stage "Building LFS"
df5e82b3 1735 buildbase
15679d9f 1736
f9783277 1737 print_build_stage "Building IPFire"
15679d9f 1738 buildipfire
5cfe86e6 1739
f9783277 1740 print_build_stage "Building installer"
df5e82b3 1741 buildinstaller
15679d9f 1742
f9783277 1743 print_build_stage "Building packages"
df5e82b3 1744 buildpackages
7a5ed24e 1745
f9783277 1746 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1747
1748 cd $BASEDIR
7a5ed24e 1749 tools/checknewlog.pl
e0c923f4 1750 tools/checkrootfiles
b307417f 1751 cd $PWD
a23731d1 1752
f9783277 1753 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1754 ;;
1755shell)
1756 # enter a shell inside LFS chroot
1757 # may be used to changed kernel settings
1758 prepareenv
1759 entershell
1760 ;;
df5e82b3 1761clean)
f9783277
MT
1762 print_line "Cleaning build directory..."
1763
df5e82b3
MT
1764 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1765 $LOSETUP -d $i 2>/dev/null
1766 done
b0c37190
MT
1767 #for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1768 # umount $i
1769 #done
df5e82b3
MT
1770 stdumount
1771 for i in `seq 0 7`; do
69a6ec55 1772 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1773 umount /dev/loop${i} 2>/dev/null;
1774 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1775 fi;
df5e82b3
MT
1776 done
1777 rm -rf $BASEDIR/build
1778 rm -rf $BASEDIR/cdrom
f9315063 1779 rm -rf $BASEDIR/packages
ebaecf2c 1780 rm -rf $BASEDIR/log
6c4cc7ea
MT
1781 if [ -h "${TOOLS_DIR}" ]; then
1782 rm -f "${TOOLS_DIR}"
df5e82b3 1783 fi
b307417f 1784 rm -f $BASEDIR/ipfire-*
f9783277 1785 print_status DONE
df5e82b3 1786 ;;
4e432799
MT
1787docker)
1788 # Build the docker image if it does not exist, yet
1789 if ! docker images -a | grep -q ^ipfire-builder; then
1790 if docker build -t ipfire-builder ${BASEDIR}/tools/docker; then
1791 print_status DONE
1792 else
1793 print_status FAIL
1794 exit 1
1795 fi
1796 fi
1797
1798 # Run the container and enter a shell
1799 docker run -it --privileged -v "${BASEDIR}:/build" -w "/build" ipfire-builder bash -l
1800 ;;
c3db995c 1801downloadsrc)
df5e82b3
MT
1802 if [ ! -d $BASEDIR/cache ]; then
1803 mkdir $BASEDIR/cache
1804 fi
ebaecf2c 1805 mkdir -p $BASEDIR/log
857d9bf2 1806 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1807 FINISHED=0
1808 cd $BASEDIR/lfs
1809 for c in `seq $MAX_RETRIES`; do
1810 if (( FINISHED==1 )); then
1811 break
1812 fi
1813 FINISHED=1
1814 cd $BASEDIR/lfs
1815 for i in *; do
1816 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1817 lfsmakecommoncheck ${i} || continue
1818
dc7d6b20 1819 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1820 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1821 if [ $? -ne 0 ]; then
f9783277 1822 print_status FAIL
df5e82b3
MT
1823 FINISHED=0
1824 else
1825 if [ $c -eq 1 ]; then
f9783277 1826 print_status DONE
df5e82b3
MT
1827 fi
1828 fi
1829 fi
1830 done
1831 done
e22c7973 1832 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1833 ERROR=0
1834 for i in *; do
1835 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1836 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1837 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1838 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1839 if [ $? -ne 0 ]; then
e22c7973 1840 echo -ne "MD5 difference in lfs/$i"
f9783277 1841 print_status FAIL
df5e82b3
MT
1842 ERROR=1
1843 fi
1844 fi
1845 done
1846 if [ $ERROR -eq 0 ]; then
e22c7973 1847 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1848 print_status DONE
e22c7973
MT
1849 else
1850 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1851 print_status FAIL
df5e82b3 1852 fi
e22c7973 1853 cd - >/dev/null 2>&1
df5e82b3 1854 ;;
df5e82b3 1855toolchain)
f9783277
MT
1856 # Clear screen
1857 ${INTERACTIVE} && clear
1858
df5e82b3 1859 prepareenv
f3b7cf47 1860 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1861 buildtoolchain
f74072a2 1862 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1863 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
d66e6fa8
MT
1864 cd $BASEDIR && tar -cf- --exclude='log/_build.*.log' build/${TOOLS_DIR} build/bin/sh log \
1865 | zstd ${ZSTD_OPT} > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst
1866 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.zst \
dc7d6b20 1867 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1868 stdumount
1869 ;;
1870gettoolchain)
df5e82b3 1871 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1872 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
d66e6fa8 1873 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.zst ]; then
5bd13f01 1874 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1875 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1876 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1877 cd $BASEDIR/cache/toolchains
d66e6fa8 1878 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.zst $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1879 if [ $? -ne 0 ]; then
dc7d6b20 1880 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1881 else
5d099c0e 1882 if [ "`md5sum $PACKAGE.tar.zst | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1883 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1884 else
1885 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1886 fi
40a4ea4c 1887 fi
712d859c
MT
1888 else
1889 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1890 fi
1891 ;;
15679d9f 1892uploadsrc)
661d9388
CS
1893 if [ -z $IPFIRE_USER ]; then
1894 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1895 print_status FAIL
661d9388
CS
1896 exit 1
1897 fi
ae23a606 1898
dbd455ef
MT
1899 URL_SOURCE="$(awk '/^URL_SOURCE/ { print $3 }' lfs/Config)"
1900
1901 rsync \
1902 --recursive \
1903 --update \
1904 --ignore-existing \
1905 --progress \
1906 --human-readable \
1907 --exclude="toolchains/" \
1908 "${BASEDIR}/cache/" \
1909 "${IPFIRE_USER}@${URL_SOURCE}"
661d9388 1910
15679d9f 1911 exit 0
0eab8e84 1912 ;;
bf7c473f 1913lang)
69a6ec55
MT
1914 echo -ne "Checking the translations for missing or obsolete strings..."
1915 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1916 $BASEDIR/tools/sort_strings.pl en
1917 $BASEDIR/tools/sort_strings.pl de
1918 $BASEDIR/tools/sort_strings.pl fr
1919 $BASEDIR/tools/sort_strings.pl es
1920 $BASEDIR/tools/sort_strings.pl pl
1921 $BASEDIR/tools/sort_strings.pl ru
1922 $BASEDIR/tools/sort_strings.pl nl
1923 $BASEDIR/tools/sort_strings.pl tr
1924 $BASEDIR/tools/sort_strings.pl it
1925 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1926 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1927 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1928 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
72c8478e 1929 $BASEDIR/tools/check_strings.pl pl > $BASEDIR/doc/language_issues.pl
69a6ec55
MT
1930 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1931 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1932 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1933 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1934 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1935 print_status DONE
69a6ec55
MT
1936
1937 echo -ne "Updating language lists..."
1938 update_language_list ${BASEDIR}/src/installer/po
1939 update_language_list ${BASEDIR}/src/setup/po
f9783277 1940 print_status DONE
bf7c473f 1941 ;;
1fb7f56e
MT
1942update-contributors)
1943 update_contributors
1944 ;;
ba137dd8
MT
1945find-dependencies)
1946 shift
1947 exec "${BASEDIR}/tools/find-dependencies" "${BASEDIR}/build" "$@"
1948 ;;
4edcd4b2
LAH
1949check-manualpages)
1950 echo "Checking the manual pages for broken links..."
1951
1952 chmod 755 $BASEDIR/tools/check_manualpages.pl
1953 if $BASEDIR/tools/check_manualpages.pl; then
1954 print_status DONE
1955 else
1956 print_status FAIL
1957 fi
1958 ;;
6b8cff41 1959*)
a55f90e9 1960 echo "Usage: $0 [OPTIONS] {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain|update-contributors|find-dependencies|check-manualpages}"
6b8cff41
MT
1961 cat doc/make.sh-usage
1962 ;;
3ea75603 1963esac
98329972 1964